package cn.dg32z.lon.commands.sub;

import cn.dg32z.libs.chengzhiya.task.mhdfscheduler.scheduler.MHDFScheduler;
import cn.dg32z.libs.net.kyori.adventure.text.Component;
import cn.dg32z.libs.net.kyori.adventure.text.event.ClickEvent;
import cn.dg32z.libs.net.kyori.adventure.text.event.HoverEvent;
import cn.dg32z.libs.org.jetbrains.annotations.NotNull;
import cn.dg32z.lon.PluginLoader;
import cn.dg32z.lon.commands.AbstractCommand;
import cn.dg32z.lon.player.PlayerData;
import java.util.List;
import java.util.stream.Collectors;
import org.bukkit.Bukkit;
import org.bukkit.GameMode;
import org.bukkit.command.CommandSender;
import org.bukkit.entity.Player;

/* loaded from: cn_dg32z_lon_commands_sub.jar:cn/dg32z/lon/commands/sub/Spectate.class */
public final class Spectate extends AbstractCommand {
    public Spectate() {
        super("Spectate a player", "lonac.commands.spectate", true);
    }

    public void execute(@NotNull Player player, @NotNull String label, @NotNull String[] args) {
        if (args.length < 2) {
            player.sendMessage(PluginLoader.INSTANCE.getMessageUtils().i18n("commands.spectate.usage"));
            return;
        }
        Player target = Bukkit.getPlayer(args[1]);
        if (target == null) {
            player.sendMessage(PluginLoader.INSTANCE.getMessageUtils().i18n("not-found").replace("%player%", args[1]));
            return;
        }
        if (target.getUniqueId().equals(player.getUniqueId())) {
            player.sendMessage(PluginLoader.INSTANCE.getMessageUtils().i18n("not-my-self"));
            return;
        }
        if (PluginLoader.INSTANCE.getSpectateManager().enable(player)) {
            PlayerData playerData = PluginLoader.INSTANCE.getPlayerDataManager().getPlayer(player);
            if (playerData == null) {
                player.sendMessage(PluginLoader.INSTANCE.getMessageUtils().i18n(target, "not-data-user"));
                return;
            } else {
                Component formattedMessage = Component.text(PluginLoader.INSTANCE.getMessageUtils().i18n(target, "commands.spectate.return")).clickEvent(ClickEvent.clickEvent(ClickEvent.Action.RUN_COMMAND, "/lonac stopspectating")).hoverEvent(HoverEvent.showText(Component.text("/lonac stopspectating")));
                playerData.getUser().sendMessage(formattedMessage);
                player.sendMessage(PluginLoader.INSTANCE.getMessageUtils().i18n(target, "commands.spectate.message"));
            }
        }
        player.setGameMode(GameMode.SPECTATOR);
        diffTeleport(target, player);
    }

    private void diffTeleport(Player target, Player player) {
        if (MHDFScheduler.isFolia()) {
            player.teleportAsync(target.getLocation());
        } else {
            player.teleport(target.getPlayer());
        }
    }

    public List<String> tabCompleter(@NotNull CommandSender sender, @NotNull String label, @NotNull String[] args) {
        if (args.length == 1) {
            return (List) Bukkit.getOnlinePlayers().stream().filter(p -> {
                return !p.equals(sender);
            }).map((v0) -> {
                return v0.getName();
            }).filter(name -> {
                return name.toLowerCase().startsWith(args[0].toLowerCase());
            }).collect(Collectors.toList());
        }
        return List.of();
    }
}
